<?php
require_once('app/config.php');
require_once('auth.php');

function is_image($file_name) {
	$fa = explode('.', $file_name);
	$ext = $fa[count($fa) - 1];
	if(preg_match('/jpg|jpeg|png|gif/i', $ext)) {
		return TRUE;
	} else {
		return FALSE;
	}
}

function build_file_icon($file_name) {
	$fa = explode('.', $file_name);
	$ext = $fa[count($fa) - 1];
	$icon_path = $_SERVER['DOCUMENT_ROOT'] . '/img/links/';
	if(file_exists($icon_path . $ext . '.gif')) {
		return "<img alt='$ext' src='/img/links/$ext.gif' border='0' width='16' height='16' /> " . $file_name;
	} else {
		return "<img alt='' src='/img/links/extern.gif' border='0' width='16' height='16' /> " . $file_name;
	}
}

function create_thumb($name, $filename, $new_w, $new_h) { // supports jpg, png and gif
	$system = explode(".", $name);
	if(preg_match("/jpg|jpeg/i", $system[count($system) - 1])) {
		$src_img = imagecreatefromjpeg($name);
	}
	if(preg_match("/png/i", $system[count($system) - 1])) {
		$src_img = imagecreatefrompng($name);
	}
	if(preg_match("/gif/i", $system[count($system) - 1])) {
		$src_img = imagecreatefromgif($name);
	}
	if(!isset($src_img)) {
		return; // not a supported image
	}
	$old_x = imagesx($src_img);
	$old_y = imagesy($src_img);
	if($old_x > $old_y) {
		$thumb_w = $new_w;
		$thumb_h = $old_y * ($new_h / $old_x);
	}
	if($old_x < $old_y) {
		$thumb_w = $old_x * ($new_w / $old_y);
		$thumb_h = $new_h;
	}
	if($old_x == $old_y) {
		$thumb_w = $new_w;
		$thumb_h = $new_h;
	}
	$dst_img = imagecreatetruecolor($thumb_w, $thumb_h);
	imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $thumb_w, $thumb_h, $old_x, $old_y); 
	if(preg_match("/png/", $system[count($system) - 1])) {
		imagepng($dst_img, $filename);
	} elseif(preg_match("/gif/", $system[count($system) - 1])) {
		imagegif($dst_img, $filename);
	} else {
		imagejpeg($dst_img, $filename);
	}
	imagedestroy($dst_img);
	imagedestroy($src_img);
	chmod($filename, 0755);
}

$imageUrl = '';
$uploaded_images = '';
$uploaded_data = '';

$up_dir = $ne2_config_info['upload_dir'];
$up_dir_rel = str_replace($_SERVER['DOCUMENT_ROOT'], '', $up_dir);

// upload
if(count($_FILES)) {
	// Doublecheck that we really had a file:
	if(!($_FILES['filAttachment']['size'])) {
		die('ERROR: No actual file uploaded!');
	} else {
		// Determine the filename to which we want to save this file:
		if(!is_dir($up_dir)) {
			mkdir($up_dir, 0755, TRUE);
		}
		
		$prx = time() . '_';
		$oriname = str_replace(' ', '_', basename($_FILES['filAttachment']['name']));
		$newname = $prx . $oriname;
		$thname = 'thumb_' . $newname;
		$newnamepath = $up_dir . $newname;
		$thnamepath = $up_dir . $thname;
		// Attempt to move the uploaded file to it's new home:
		if(!(move_uploaded_file($_FILES['filAttachment']['tmp_name'], $newnamepath))) {
			die('ERROR: A problem occurred during file upload!');
		} else {
			// It worked!
			chmod($newnamepath, 0755);
			if(is_image($newname)) {
				create_thumb($newnamepath, $thnamepath, 80, 80);
			}
			$imageUrl = $up_dir_rel . $newname;
		}
	}
}

// list uploaded images
$dir = $ne2_config_info['upload_dir'];
if(is_dir($dir)) {
	if($dh = opendir($dir)) {
		while(($file = readdir($dh)) !== FALSE) {
			if(($file != '.') && ($file != '..')) {
				if((substr($file, 0, 6) == 'thumb_') && is_image($file)) {
					$file1 = substr($file, 6);
					$uploaded_images .= "<span><a href='javascript:;' name='sel_img' rel='$up_dir_rel" . "$file1'><img alt='' src='$up_dir_rel" . "$file' /></a>";
					$uploaded_images .= " <a href='javascript:;' name='del_img' rel='$file1'>X</a></span> &nbsp;";
				} else {
					if(!is_image($file)) {
						$uploaded_data .= "<li><a href='javascript:;' name='sel_img' rel='$up_dir_rel" . "$file'>" . build_file_icon($file) . "</a>";
						$uploaded_data .= " <a href='javascript:;' name='del_img' rel='$file'>X</a></li>";
					}
				}
			}
		}
		closedir($dh);
	}
}

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Bilder verwalten - RRZE NavEditor 2.0 - Prototype</title>
<link rel="stylesheet" type="text/css" href="css/styles.css" />
<script type="text/javascript" src="js/jquery-1.3.1.min.js"></script>
<script type="text/javascript">
<!--
$(document).ready(function() {
	$("#uploadedList a[name='sel_img']").click(function() {
		$("#txtImgUrl").val($(this).attr("rel"));
	});
	
	var img_to_delete = "";
	
	$("#uploadedList a[name='del_img']").click(function() {
		if(confirm("Are you sure to delete this file?")) {
			img_to_delete = $(this).attr("rel");
			$.post("app/edit_up_img.php?r=" + Math.random(), {
				'oper': 'delete',
				'file_name': img_to_delete
			}, function(rdata) {
				if(rdata == "[OK]") {
					$("#uploadedList a[rel=" + img_to_delete + "]").parent().remove();
				}
			});
		}
	});
});
// -->
</script>
</head>

<body id="bd_Bilder">
<div id="wrapper">
	<h1 id="header">RRZE NavEditor 2.0 <sup>beta</sup></h1>
	<div id="navBar">
		<?php require('common_nav_menu.php'); ?>
	</div>
	
	<div id="contentPanel1">
		<form action="<?php echo($_SERVER['PHP_SELF']); ?>" method="post" enctype="multipart/form-data" name="frmUpload" id="frmUpload">
			<fieldset>
				<legend>Datei hochladen &amp; URL (zum Copy &amp; Paste)</legend>
				<label for="filAttachment">Datei zum hochladen:</label>
				<input type="file" id="filAttachment" name="filAttachment" class="textBox" />
				<input type="submit" id="btnUpload" name="btnUpload" value="Hochladen" class="button" />
				<input type="hidden" id="MAX_FILE_SIZE" name="MAX_FILE_SIZE" value="1048576" />
				<hr size="1" noshade="noshade" />
				<label>Datei-URL: </label>
				<input type="text" id="txtImgUrl" name="txtImgUrl" class="textBox" onmouseover="this.select();" value="<?php echo($imageUrl); ?>" size="80" />
			</fieldset>
		</form>
		<div id="uploadedList">
			<div style="width:49%;float:left;">
				<fieldset>
					<legend>Hochgeladene Bilde</legend>
					<div id="uploadedImgs"><?php echo($uploaded_images); ?></div>
				</fieldset>
			</div>
			<div style="width:49%;float:right;">
				<fieldset>
					<legend>Hochgeladene Dateien</legend>
					<div id="uploadedData"><ul><?php echo($uploaded_data); ?></ul></div>
				</fieldset>
			</div>
			<div class="z"></div>
		</div>
	</div>
	
<?php require('common_footer.php'); ?>
</div>
</body>

</html>
