<?php
require_once('auth.php');
if(!$is_admin) { // this page is for admin only!
	auth401();
}
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>User management - RRZE NavEditor 2.0 Beta</title>
<link rel="stylesheet" type="text/css" href="css/styles.css" />

<script type="text/javascript" src="js/jquery-1.3.1.min.js"></script>
<script type="text/javascript" src="js/json2.js"></script>
<script type="text/javascript" src="js/naveditor2.js"></script>
<script type="text/javascript">
var admin_uname = "<?php echo($_SERVER['SERVER_ADMIN']); ?>";

function loadContentCallback(data) {
	var ulhtml = "<ul>";
	for(var i = 0; i < data.length; i++) {
		ulhtml += "<li><input class=\"button\" rel=\"" + data[i].permission + "\" type=\"button\" id=\"E_" + data[i].user_name + "\" value=\"Edit\" /> <input class=\"button\" type=\"button\" id=\"D_" + data[i].user_name + "\" value=\"X\" /> " + data[i].user_name + "</li>";
	}
	ulhtml += "</ul>";
	$("#userList").html(ulhtml);
	
	$("#userList ul li input").click(function() {
		var operstr = $(this).attr("id");
		var operarr = operstr.split("_");
		var oper = operarr[0];
		var uname = operarr[1];
		if(oper == "E") {
			$("#btnUpdate").removeAttr("disabled");
			$("#selPermission1").removeAttr("disabled");
			$("#txtUserName1").val(uname);
			$("#selPermission1").val($(this).attr("rel"));
		}
		if(oper == "D") {
			if(confirm("Are you sure to remove this user?")) {
				removeUser(uname);
			}
		}
	});
	
	loadNavTreeOptions();
}

var _navTreeOptString = "";
var _indent = -1;

function loadTreeCallback(rdata) {
	var jsonData = rdata.A;
	navTreeOper._reIndex(jsonData);
	navTreeOper._jsonNavNormal = jsonData;
	navTreeOper.addPathInfo(jsonData);
	generateNavTreeOptions(jsonData);
	$("#selPermission").html(_navTreeOptString);
	$("#selPermission1").html(_navTreeOptString);
}

function makeIndent(mal) {
	var r = "";
	if(mal <= 0) {
		return "";
	} else {
		for(var i = 0; i < mal; i++) {
			r += "&nbsp; &nbsp; ";
		}
		return r;
	}
}

function generateNavTreeOptions(jsonData) {
	if(jsonData.length < 1) {
		return;
	}
	_indent++;
	for(var i = 0; i < jsonData.length; i++) {
		_navTreeOptString += "<option value='" + jsonData[i].path + "'>" + makeIndent(_indent) + jsonData[i].title + "</option>";
		if(jsonData[i].child.length > 0) {
			generateNavTreeOptions(jsonData[i].child); // recursive
		}
	}
	_indent--;
}

function loadNavTreeOptions() {
	$.getJSON("app/load_tree_data.php?r=" + Math.random(), loadTreeCallback); // load tree data
}

function removeUser(userName) {
	admin_uname = admin_uname.split("@");
	admin_uname = admin_uname[0];
	if(admin_uname == userName) {
		alert("You cannot remove SERVER_ADMIN!");
		return;
	}
	$.post("app/edit_user.php", {
		"json_oper": "remove_user",
		"user_name": userName
	}, removeUserCallback);
}

function removeUserCallback(data) {
	alert(data);
	location.reload();
}

function updateUserCallback(data) {
	alert(data);
	location.reload();
}

function createUserCallback(data) {
	alert(data);
	location.reload();
}

/* ---------- Here comes jQuery: ---------- */
$(document).ready(function() {
	$("#txtUserName1").val("");
	$("#txtPassword1").val("");
	$("#selPermission1").attr("disabled", "disabled");
	
	$.getJSON("app/edit_user.php?r=" + Math.random(), {
		"json_oper": "get_users"
	}, loadContentCallback);
	
	$("#btnUpdate").click(function() {
		$.post("app/edit_user.php", {
			"json_oper": "update_user",
			"user_name": $("#txtUserName1").val(),
			"new_password": $("#txtPassword1").val(),
			"new_permission": $("#selPermission1").val()
		}, updateUserCallback);
	});
	
	$("#btnCreate").click(function() {
		var userName = $("#txtUserName").val();
		var passWord = $("#txtPassword").val();
		var permission = $("#selPermission").val();
		if(userName == "" || passWord == "") {
			alert("User-Name and/or Password cannot be empty!");
			return;
		}
		$.post("app/edit_user.php", {
			"json_oper": "create_user",
			"user_name": userName,
			"password": passWord,
			"permission": permission
		}, createUserCallback);
	});
});
</script>
</head>

<body id="bd_User">
<div id="wrapper">
	<h1 id="header">RRZE NavEditor 2.0 <sup>beta</sup></h1>
	<div id="navBar">
		<?php require('common_nav_menu.php'); ?>
	</div>
	
	<div id="contentPanel1">
		<form action="" method="post" name="frmEdit" id="frmEdit">
			<fieldset>
				<legend>Benutzer erstellen</legend>
				<label for="txtUserName">User-Name:</label>
				<input type="text" id="txtUserName" name="txtUserName" class="textBox" size="16" />
				<label for="txtPassword">Passwort:</label>
				<input type="password" id="txtPassword" name="txtPassword" class="textBox" size="16" />
				<label for="selPermission">Zugriff:</label>
				<select id="selPermission" class="textBox"></select>
				<input type="button" id="btnCreate" name="btnCreate" value="Ausf&uuml;hren" class="button" />
			</fieldset>
			<fieldset>
				<legend>Benutzer aktualisieren</legend>
				<label for="txtUserName1">User-Name:</label>
				<input type="text" id="txtUserName1" name="txtUserName1" class="textBox" size="16" readonly="readonly" />
				<label for="txtPassword1">Passwort:</label>
				<input type="password" id="txtPassword1" name="txtPassword1" class="textBox" size="16" />
				<label for="selPermission1">Zugriff:</label>
				<select id="selPermission1" class="textBox" disabled="true"></select>
				<input type="button" id="btnUpdate" name="btnUpdate" value="Ausf&uuml;hren" class="button" disabled="true" />
			</fieldset>
			<fieldset>
				<legend>Benutzerliste:</legend>
				<div id="userList"></div>
			</fieldset>
		</form>
	</div>
	
<?php require('common_footer.php'); ?>	
</div>
</body>

</html>
